

//////////////////Task BLGREEN    demo of asymmetrical flashing
void blgreen1 () {
  WPIN(GREEN, HIGH);  
  mtdelay (100, blgreen2); 
}
void blgreen2 () {
  WPIN(GREEN, LOW) ;  
  mtdelay (700, blgreen1); 
}
///////////////////Task BLBLUE     flashing is controlled by Task PUSHBUTTON 
void blblue1 () {
  WPIN(BLUE , !RPIN(BLUE) ) ;  
  mtdelay (100, blblue1); 
}

/////////////////Task PUSHBUTTON     control of Task BLBLUE by pushbutton
void ledon () {   //support of stop function
  WPIN(BLUE, HIGH);
}

void pushbutton1 () {               //reserved for inits
  mtcoop (pushbutton2);     
}
void pushbutton2 () {               //begin of realtime compatible loop
  mtpin (BUTTON, LOW, pushbutton3); //waiting for pushbutton is pressed
}
void pushbutton3 () {               //control Task BLBLUE
  WPIN(YELLOW, HIGH);               //push indicator
  if (gettaskstate(BLBLUE) == TERMINATED) 
    start (BLBLUE, blblue1);
  else stop (BLBLUE, ledon);
  mtpin (BUTTON, HIGH, pushbutton4);   //waiting for pushbutton is released
}
void pushbutton4 () {
  WPIN(YELLOW, LOW);
  mtcoop (pushbutton2);                //repeat endless loop
}


