
//////////////////////////Task REAC      reaction time measurement
//If BUTTON is pressed, flashing LED YELLOW turns LOW
//A short time LED YELLOW turns HIGH. 
//Then user has to push BUTTON as quickly he can.
//Reaction time is displayed.

#define REACLED  YELLOW
long tbegin;
long treac;

void reac1 () {     
  mtcoop ( reac2);
}
void reac2 () {                //flashing LED by an embedded 100 ms cycle 
  WPIN(REACLED, !RPIN (REACLED) ); 
  mtdelay (100, reac2);               
  mtpin (BUTTON, LOW, reac3);  //waitung for push 
}   
void reac3 () {           
  WPIN(REACLED,LOW ); 
  mtdelay ( 1500 + rand() % 4000 , reac4);  //random wait time 1,5 - 5,5 s
  mtpin ( BUTTON, LOW, reac6);              //button pressed too early, process aborted
} 
void reac4 () {                   //start of measurement 
  WPIN(REACLED,HIGH );            //now user must react as quickly as possible  
  tbegin = getclock();           
  mtdelay ( 2000, reac6);         //button not pressed within 2 s, process aborted
  mtpin ( BUTTON, LOW, reac5);    //waiting for push
}
void reac5 () {                    //stop of measurement
  treac = getclock() - tbegin;     //calculate reaction time
  PR ("Reac time ms: " );
  PRln (treac );  
  WPIN(REACLED,LOW );  
  mtdelay (1500, reac2);           
}
void reac6 () {                    //no result
  PRln ( "too early or button not pressed");   
  mtcoop (reac2);        
}  

                  