
//////////Task PRIME        calculation of prime numbers > 1000000001,
//so it takes more than one second to find next and serial monitor is not 
//flooded by information. 
//To check results use  https://www.arndt-bruenner.de/mathe/scripts/primzahlen.htm 
//Task PRIME makes system do more usefull things in the background than idle cycles.
//To pause or continue calculation user is entering:  m # 

#define COLUMNS  8
long testnum;             //current calculated number
long divi;                //current divisor
long maxdivi;             //max divisor
char columns = 0;      
char primestop = 1;       //pause/continue 

void prime1 (void) {      //init task
  testnum = 1000000001;   //must be an odd number!!!!        
  mtcoop (prime2);
}

void prime2 (void) {      // init test
    testnum += 2 ;         
    divi = 1;                 
    maxdivi = sqrt(testnum) ;     
    mtcoop (prime3);     
}     

void prime3 (void) {      //in case of pause prime3 loop is executed
  if (primestop)          
    mtdelay (100, prime3);
  else mtcoop ( prime4);
}

void prime4 (void) {             //test 
  divi += 2;                  
  if ( !(testnum % divi) )       //-> remainder == 0 therefore not a prime number           
    mtcoop (prime2);             //next number                       
  else if (divi <= maxdivi )    
         mtcoop (prime4);        //continue test    
       else {                  
         PR (testnum);           //this is a prime number -> output
         if (++columns < COLUMNS)         
           PR (" ");
         else {
           columns = 0;
           if (!primestop) PRln ();
         }
         if (primestop) PRln ("\nm halt prime");        
         mtcoop (prime2);        //next number   
       }
}


