/*  Copyright 2023 Dieter Holzhäuser  E-Mail: dieter.holzhauser@gmail.com
  
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published serbuf
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <mtRTOS2407.h>
//                  Minimal mtRTOS Sketch
//         Open serial monitor and set 38400 Baud

////////////////Task Definitions  (0 to 18)
#define HELLO      0  

///////////////////Task HELLO    
void hello () {
  PR ("Hello World");      // PR <-> Serial.print
}

/////////////////
void setup () {        //in case of upload setup old is executed and then setup new                
  initmt();                //init Multitasking Kernel  
  Serial.begin (38400);
  start (HELLO, hello);      
  runner ();               //main loop of mtRTOS, avoid loop()                                    
}
