
///Serial user input library interface:
//Semaphore  INPSEM   ->  serial user input has taken place
//extern char id      ->  ID:   0 (LF), 'a'to'z' , 'A'to'Z'
//extern char inum    ->  number of numeric data, inum == 0 means input of id only
//extern long lnum [MAXNUM]  ->  array of numeric data 

//     Serial user input format 
//  LF  or  id LF  or  id num (num) (num) (num) LF    (blank(s) as separator)
//      Format of num (digits 123 as example)
//  #  or  123  or  -123  or  1.23  or  -1.23   (# -> numeric equivalent of exeptions)



///////////////Task COMM       Serial user input evaluation using library interface
String p = "p ";
String s = "SET ";
String g = "GET ";
String sg = "songnr: ";
String oor = "out of range";

void playstart () { 
  start (PLAY, play1);   
  mtcoop (comm2);
}

void do_songnr () {
  char is_song = 0;
  if (inum) {
    if (lnum[0] == NONB) {         // set #
      songnr = lnum[0];
      playstop (); 
      PRln  (p + s + sg + "#");    // stop            
    }
    else  if (lnum[0] >= 0 && lnum[0] < MAXSONGS ) {
            playstop ();                     //set songnr
            if (songnr != NONB) is_song = 1;
            songnr = lnum[0];  
            PR (p + s + sg); 
            PRln (songnr);
            if (is_song) {
              mtdelay ( 1500, playstart);
              return;
            }
            else start (PLAY, play1);   
          }
          else  PRln (p + oor);    // out of range
  }
  else {
    PR (p + g + sg);        //get data
    if (songnr == NONB)
      PRln ("#");
    else PRln (songnr);
  }             
  mtcoop (comm2);
}

void comm1 () {
  mtcoop (comm2);
}
void comm2 () {
  mtsema (INPSEM, comm3);
}
void comm3 () {                    // id  evaluation 
  if (id == 'i' ) {
    PR ("i idle: ");
    PRln ( getidle() );
  }
  else if (id == 'p' ) {              
         mtcoop (do_songnr );
         return;
       }
       else if (id == 'm' ) {             //prime numbers   halt/continue
              if (inum && lnum[0] == NONB ) {
                primestop = !primestop;
                if (!primestop) PRln ("m cont prime");
              }
              else PRln ("m # expected");         
            }
            else PRln ("Valid IDs: i idle, p play, m prime");   
  mtcoop (comm2);
}


